#include <opencv2/opencv.hpp>

int main_processor()
{
    cv::VideoCapture video("../record.avi"); 
    double fps = video.get(cv::CAP_PROP_FPS);

    cv::Mat frame;
    video >> frame;

    cv::VideoWriter out("../record2.avi",cv::VideoWriter::fourcc('M','J','P','G'),fps, frame.size());

    double angle = 0;
    int sig = 1;
    cv::RNG random;
    for (;;) {
        if (random.uniform(0.0,1.0) < 0.025*std::abs(angle))
            sig = - int(angle/std::abs(angle));
        
        angle += sig*0.25;
        cv::Mat warp_matrix = cv::getRotationMatrix2D(cv::Point(frame.cols/2,frame.rows/2),angle,1), rotated;
        cv::warpAffine(frame, rotated, warp_matrix,frame.size());

        cv::imshow("video",rotated);
        int key = cv::waitKey(1);
        if (key == 27) break;

        out << rotated;
        
        video >> frame;
        if (frame.empty()) break;
    }
    
    out.release();
    video.release();
    cv::destroyAllWindows();
    return 0;
}

