import numpy as np
import cv2

# get images from left and right camera
left_image = cv2.imread('../tsukuba_L.png',cv2.IMREAD_COLOR)
right_image = cv2.imread('../tsukuba_R.png',cv2.IMREAD_COLOR)

# turn color images to greyscale images
left_image = cv2.cvtColor(left_image, cv2.COLOR_BGR2GRAY)
right_image = cv2.cvtColor(right_image, cv2.COLOR_BGR2GRAY)

# calculate depth map
#stereo = cv2.createStereoBM(numDisparities=16, blockSize=15) # OpenCV3
stereo = cv2.StereoBM_create(numDisparities=16, blockSize=15) # OpenCV4
disparity = stereo.compute(left_image,right_image)

# show the result
normalized_disparity = cv2.normalize(disparity, None, alpha=0, beta=255, norm_type=cv2.NORM_MINMAX, dtype=cv2.CV_8U)
cv2.imshow('disparity',normalized_disparity)
cv2.waitKey(0)
cv2.destroyAllWindows()
cv2.imwrite('disparity.png',normalized_disparity)
